import { SVGProps } from "react";

type StarProps = {
  hovered?: boolean;
  selected: boolean;
} & SVGProps<SVGSVGElement>;

export const Star = ({ hovered, selected, ...svgProps }: StarProps) => (
  <svg
    version="1.1"
    id="Layer_1"
    xmlns="http://www.w3.org/2000/svg"
    x="0px"
    y="0px"
    viewBox="0 0 512.001 512.001"
    width="2.2em"
    height="1.7em"
    data-testid={`star${selected ? "-selected" : ""}`}
    {...svgProps}
  >
    <path
      fill="#FFD92D"
      fillOpacity={selected ? 1 : hovered ? 0.2 : 0}
      d="M359.736,158.439l115.73,16.093c26.037,3.62,36.621,35.526,17.909,53.991l-83.169,82.069
  c-7.43,7.332-10.777,17.852-8.95,28.129l20.457,115.039c4.603,25.882-22.471,45.807-45.814,33.716L272.146,433.74
  c-9.269-4.801-20.308-4.734-29.517,0.181l-103.087,55.005c-23.193,12.375-50.508-7.216-46.224-33.152l19.045-115.281
  c1.702-10.3-1.774-20.776-9.294-28.017l-84.168-81.044c-18.937-18.234-8.745-50.267,17.246-54.206l115.524-17.51
  c10.322-1.565,19.211-8.107,23.774-17.496l51.069-105.092c11.49-23.645,45.103-23.85,56.883-0.349l52.352,104.459
  C340.427,150.569,349.396,157.001,359.736,158.439z"
    />
    <path
      fill="#FFE571"
      fillOpacity={selected ? 1 : hovered ? 0.2 : 0}
      d="M121.015,216.636c0-18.048,1.798-35.636,4.438-52.947l-89.306,13.534
  c-25.992,3.94-36.182,35.972-17.246,54.207l84.172,81.045c7.518,7.241,10.994,17.717,9.29,28.017L93.318,455.773
  c-4.287,25.936,23.033,45.527,46.224,33.152l72.007-38.422C155.471,388.6,121.015,306.743,121.015,216.636z"
    />
    <path
      fill="#FFA81E"
      fillOpacity={selected ? 1 : hovered ? 0.2 : 0}
      d="M493.378,228.524c18.71-18.464,8.125-50.37-17.91-53.991l-115.731-16.094
  c-10.34-1.438-19.312-7.871-23.985-17.204L283.4,36.776c-11.784-23.501-45.398-23.296-56.884,0.349l-21.785,44.821
  c74.297,49.588,123.276,134.128,123.276,230.154c0,48.197-12.38,93.478-34.048,132.935l81.94,42.44
  c23.342,12.09,50.417-7.834,45.816-33.716l-20.461-115.038c-1.825-10.278,1.521-20.797,8.95-28.129L493.378,228.524z"
    />
    <g>
      <path
        fill="#1C2042"
        d="M499.805,235.052c11.155-11.008,15.02-27.086,10.086-41.96
  	c-4.935-14.875-17.642-25.455-33.163-27.613c-4.996-0.687-9.633,2.798-10.329,7.807c-0.696,5.008,2.799,9.633,7.807,10.329
  	c8.698,1.208,15.541,6.908,18.307,15.242c2.766,8.336,0.685,16.996-5.567,23.164l-83.169,82.069
  	c-9.579,9.451-13.891,23.003-11.533,36.249l20.457,115.039c1.538,8.646-1.766,16.914-8.84,22.12
  	c-7.075,5.207-15.951,5.901-23.75,1.863l-103.753-53.737c-11.949-6.187-26.169-6.102-38.037,0.233l-103.087,55.005
  	c-7.75,4.134-16.635,3.547-23.772-1.572c-7.137-5.118-10.543-13.348-9.112-22.01l19.047-115.281
  	c2.195-13.274-2.283-26.772-11.976-36.104L25.253,224.85c-6.327-6.091-8.514-14.724-5.85-23.093
  	c2.662-8.369,9.435-14.152,18.119-15.468l115.525-17.51c13.301-2.016,24.754-10.446,30.637-22.546l51.069-105.095
  	c3.838-7.899,11.371-12.646,20.154-12.699c0.05,0,0.1,0,0.151,0c8.718,0,16.247,4.647,20.159,12.453l52.353,104.459
  	c6.027,12.028,17.582,20.316,30.909,22.169l28.135,3.912c5.001,0.699,9.633-2.798,10.329-7.807
  	c0.696-5.008-2.799-9.633-7.807-10.329l-28.135-3.912c-7.357-1.023-13.736-5.598-17.063-12.237L291.583,32.688
  	c-6.983-13.933-20.964-22.558-36.532-22.558c-0.085,0-0.173,0-0.259,0c-15.672,0.096-29.661,8.913-36.51,23.008l-51.067,105.094
  	c-3.247,6.68-9.57,11.334-16.912,12.447L34.776,168.186c-15.495,2.348-28.071,13.085-32.823,28.018
  	c-4.752,14.934-0.69,30.964,10.599,41.832l84.168,81.045c5.351,5.152,7.822,12.603,6.611,19.93L84.286,454.294
  	c-2.555,15.462,3.771,30.742,16.504,39.874c7.126,5.111,15.43,7.703,23.785,7.703c6.577,0,13.186-1.606,19.275-4.856
  	l103.088-55.005c6.55-3.498,14.401-3.547,20.997-0.128l103.753,53.737c13.913,7.204,30.399,5.915,43.024-3.376
  	c12.621-9.289,18.757-24.645,16.012-40.073l-20.457-115.039c-1.3-7.313,1.079-14.793,6.367-20.01L499.805,235.052z"
      />
      <path
        fill="#1C2042"
        d="M444.748,179.518l6.095,0.847c0.428,0.06,0.852,0.088,1.273,0.088c4.497,0,8.419-3.315,9.056-7.895
  	c0.696-5.008-2.799-9.633-7.807-10.329l-6.095-0.847c-4.999-0.687-9.632,2.798-10.329,7.807
  	C436.245,174.196,439.741,178.821,444.748,179.518z"
      />
    </g>
    <g>
      <path
        fill="#FFFFFF"
        d="M132.884,447.394c-4.964-0.961-8.209-5.764-7.248-10.728l11.354-58.645
  	c0.961-4.964,5.764-8.209,10.728-7.248c4.964,0.961,8.209,5.764,7.248,10.728l-11.354,58.645
  	C142.652,445.11,137.849,448.354,132.884,447.394z"
      />
      <path
        fill="#FFFFFF"
        d="M150.596,355.916c-4.964-0.961-8.209-5.764-7.248-10.728l1.179-6.091
  	c0.961-4.964,5.764-8.209,10.728-7.248c4.964,0.961,8.209,5.764,7.248,10.728l-1.179,6.091
  	C160.363,353.634,155.56,356.878,150.596,355.916z"
      />
    </g>
  </svg>
);
